
    <!DOCTYPE html>
    <html>
      <head>
        <meta charset="utf-8">
      </head>
      <body>
        <div class="marpit"><svg data-marpit-svg="" viewBox="0 0 1280 5000"><foreignObject width="1280" height="5000"><section id="1" data-marpit-fragments="16">
<h1>JDBC</h1>
<p>В этом домашнем задании вам предстоит реализовать два обработчика — вывод списка всех статей с пейджингом (пейджинг - это постраничный вывод) и просмотр данных конкретной статьи. Отличие от предыдущих заданий в том, что мы работаем с базой данных. Для работы с базой данных будем использовать JDBC. JDBC (Java DataBase Connectivity) — это стандартный интерфейс, предназначенный для взаимодействия Java-приложения с различными  базами данных.</p>
<h2>Ссылки</h2>
<ul>
<li data-marpit-fragment="1"><a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.sql/java/sql/Connection.html">Интерфейс Connection, описывющий соединение с базой данных</a></li>
<li data-marpit-fragment="2"><a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.sql/java/sql/Connection.html#prepareStatement(java.lang.String)">Метод prepareStatement()</a></li>
<li data-marpit-fragment="3"><a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.sql/java/sql/PreparedStatement.html">Объект PreparedStatement, представляющий предварительно скомпилированный SQL запрос</a></li>
<li data-marpit-fragment="4"><a href="https://ru.hexlet.io/courses/rdb-basics/lessons/limit/theory_unit">Ограничение выборки при помощи LIMIT и OFFSET</a></li>
<li data-marpit-fragment="5"><a href="https://docs.oracle.com/en/java/javase/11/docs/api/java.sql/java/sql/ResultSet.html">ResultSet — объект, представляющий результат выполнения запроса в базу</a></li>
<li data-marpit-fragment="6"><a href="https://docs.oracle.com/javase/8/docs/api/java/sql/ResultSet.html#first--">Метод first() — перемещает курсор на первую строку объекта ResultSet</a></li>
<li data-marpit-fragment="7"><a href="https://javaee.github.io/javaee-spec/javadocs/javax/servlet/ServletRequest.html#getParameter-java.lang.String-">Получение параметра строки запроса</a></li>
<li data-marpit-fragment="8"><a href="https://www.thymeleaf.org/doc/tutorials/3.0/usingthymeleaf.html#link-urls">Модификатор th:href — позволяет динамически создавать ссылки в шаблонах. Вычисляет URL ссылки и устанавливает его как значение атрибута href тэга &lt;a&gt;</a></li>
<li data-marpit-fragment="9"><a href="https://www.thymeleaf.org/doc/tutorials/3.0/usingthymeleaf.html#using-texts">Модификатор th:text — формирует текст и подставляет результат, как тело тега</a></li>
</ul>
<h2>src/main/java/exercise/App.java</h2>
<h2>Задачи</h2>
<ul>
<li data-marpit-fragment="10">
<p>Создайте соединение с базой данных H2. Соединение с базой данных происходит при помощи драйвера и описывается интерфейсом <code>Connection</code>. Для этого вам понадобится указать путь к файлу, в котором будет находится база данных. Выберите название по своему усмотрению.</p>
<pre><code class="language-java"><span class="hljs-comment">// Создаёт базу данных hexlet и размещает файл в текущей директории</span>
Connection connection = DriverManager.getConnection(<span class="hljs-string">&quot;jdbc:h2:./hexlet&quot;</span>);
</code></pre>
<p>Соединение должно находится с переменной с именем <code>connection</code>, так как дальше оно передаётся в метод getApp() при создании приложения.</p>
</li>
<li data-marpit-fragment="11">
<p>Выполните запросы, которые находятся в файле <em>init.sql</em>. Эти запросы создадут в базе данных таблицу и заполнят её данными. Чтобы получить содержимое файла, воспользуйтесь методом <code>getFileContent()</code>. Этот метод уже создан в классе.</p>
</li>
</ul>
<h2>src/main/java/exercise/servlet/ArticlesServlet.java</h2>
<p>Типичные таблицы в веб-проектах содержат огромное количество данных, поэтому их никогда не показывают на страницах сразу все. Обычно выводится лишь небольшая часть — например, 10 строк. Пользователь, просмотрев первые 10 записей, может захочет посмотреть следующие 10. Для этого используется пейджинг — специальный механизм, который позволяет перемещаться по страницам.</p>
<h2>Задачи</h2>
<ul>
<li data-marpit-fragment="12">Допишите обработчик <code>showArticles()</code>, который выводит список всех статей. Статьи находятся в базе данных. Каждая статья содержит 3 поля — <code>id</code>, <code>title</code> и <code>body</code>. Соединение с базой данных находится в переменной <code>connection</code>. Список статей должен выводиться с пейджингом по 10 статей на странице. На первой странице первые десять постов, на второй вторые десять и так далее. Переключение между страницами сделайте с помощью двух ссылок: назад и вперед. То, какая сейчас страница открыта, определяется параметром <code>page</code> в строке запроса. По умолчанию загружается первая страница. Например, GET-запрос на адрес <em>/articles</em> (то же самое, что запрос на <em>/articles?page=1</em>) откроет первую страницу. Запрос на адрес <em>/articles?page=3</em> откроет третью страницу.</li>
</ul>
<h2>src/main/webapp/WEB-INF/templates/articles/index.html</h2>
<h2>Задачи</h2>
<ul>
<li data-marpit-fragment="13">В шаблоне организуйте вывод ссылок &quot;Prev&quot; и &quot;Next&quot; для переключения между страницами списка. Если хотите сделать ссылки красивыми, используйте классы Bootstrap.</li>
</ul>
<pre><code class="language-html"><span class="hljs-tag">&lt;<span class="hljs-name">nav</span>&gt;</span>
  <span class="hljs-tag">&lt;<span class="hljs-name">ul</span> <span class="hljs-attr">class</span>=<span class="hljs-string">&quot;pagination justify-content-center&quot;</span>&gt;</span>
    <span class="hljs-tag">&lt;<span class="hljs-name">li</span> <span class="hljs-attr">class</span>=<span class="hljs-string">&quot;page-item&quot;</span>&gt;</span>
      <span class="hljs-tag">&lt;<span class="hljs-name">a</span> <span class="hljs-attr">class</span>=<span class="hljs-string">&quot;page-link&quot;</span> <span class="hljs-attr">href</span>=<span class="hljs-string">&quot;#&quot;</span>&gt;</span>Prev<span class="hljs-tag">&lt;/<span class="hljs-name">a</span>&gt;</span>
    <span class="hljs-tag">&lt;/<span class="hljs-name">li</span>&gt;</span>
    <span class="hljs-tag">&lt;<span class="hljs-name">li</span> <span class="hljs-attr">class</span>=<span class="hljs-string">&quot;page-item&quot;</span>&gt;</span>
      <span class="hljs-tag">&lt;<span class="hljs-name">a</span> <span class="hljs-attr">class</span>=<span class="hljs-string">&quot;page-link&quot;</span> <span class="hljs-attr">href</span>=<span class="hljs-string">&quot;#&quot;</span>&gt;</span>Next<span class="hljs-tag">&lt;/<span class="hljs-name">a</span>&gt;</span>
    <span class="hljs-tag">&lt;/<span class="hljs-name">li</span>&gt;</span>
  <span class="hljs-tag">&lt;/<span class="hljs-name">ul</span>&gt;</span>
<span class="hljs-tag">&lt;/<span class="hljs-name">nav</span>&gt;</span>
</code></pre>
<h2>src/main/webapp/WEB-INF/templates/articles/show.html</h2>
<h2>Задачи</h2>
<p>Организуйте в шаблоне вывод информации о конкретной статье. Выводиться должно название и содержание статьи.</p>
<h2>Подсказки</h2>
<ul>
<li data-marpit-fragment="14">В этом и следующих домашних задания используется строенная база данных H2. В упражнении она работает &quot;из коробки&quot;. Устанавливать базу данных у себя локально не требуется.</li>
<li data-marpit-fragment="15">При реализации пейджинга для составления запроса используйте <code>LIMIT</code> и смещение <code>OFFSET</code>.</li>
<li data-marpit-fragment="16">Для того, чтобы реализовать ссылки &quot;Вперед&quot; и &quot;Назад&quot; для переключения между страницами списка, вам потребуется передать в шаблон, помимо списка статей, еще номер текущей страницы.</li>
</ul>
</section>
<script>!function(){"use strict";const t="marpitSVGPolyfill:setZoomFactor,",e=Symbol();let r,o;function n(n){const i="object"==typeof n&&n.target||document,a="object"==typeof n?n.zoom:n;window[e]||(Object.defineProperty(window,e,{configurable:!0,value:!0}),window.addEventListener("message",(({data:e,origin:r})=>{if(r===window.origin)try{if(e&&"string"==typeof e&&e.startsWith(t)){const[,t]=e.split(","),r=Number.parseFloat(t);Number.isNaN(r)||(o=r)}}catch(t){console.error(t)}})));let l=!1;Array.from(i.querySelectorAll("svg[data-marpit-svg]"),(t=>{var e,n,i,s;t.style.transform||(t.style.transform="translateZ(0)");const c=a||o||t.currentScale||1;r!==c&&(r=c,l=c);const d=t.getBoundingClientRect(),{length:u}=t.children;for(let r=0;r<u;r+=1){const o=t.children[r],a=o.getScreenCTM();if(a){const t=null!==(n=null===(e=o.x)||void 0===e?void 0:e.baseVal.value)&&void 0!==n?n:0,r=null!==(s=null===(i=o.y)||void 0===i?void 0:i.baseVal.value)&&void 0!==s?s:0,l=o.firstElementChild,{style:u}=l;u.transformOrigin||(u.transformOrigin=`${-t}px ${-r}px`),u.transform=`scale(${c}) matrix(${a.a}, ${a.b}, ${a.c}, ${a.d}, ${a.e-d.left}, ${a.f-d.top}) translateZ(0.0001px)`}}})),!1!==l&&Array.from(i.querySelectorAll("iframe"),(({contentWindow:e})=>{null==e||e.postMessage(`${t}${l}`,"null"===window.origin?"*":window.origin)}))}r=1,o=void 0;const i=(t,e,r)=>{if(t.getAttribute(e)!==r)return t.setAttribute(e,r),!0};function a({once:t=!1,target:e=document}={}){const r="Apple Computer, Inc."===navigator.vendor?[n]:[];let o=!t;const a=()=>{for(const t of r)t({target:e});!function(t=document){Array.from(t.querySelectorAll('svg[data-marp-fitting="svg"]'),(t=>{var e;const r=t.firstChild,o=r.firstChild,{scrollWidth:n,scrollHeight:a}=o;let l,s=1;if(t.hasAttribute("data-marp-fitting-code")&&(l=null===(e=t.parentElement)||void 0===e?void 0:e.parentElement),t.hasAttribute("data-marp-fitting-math")&&(l=t.parentElement),l){const t=getComputedStyle(l),e=Math.ceil(l.clientWidth-parseFloat(t.paddingLeft||"0")-parseFloat(t.paddingRight||"0"));e&&(s=e)}const c=Math.max(n,s),d=Math.max(a,1),u=`0 0 ${c} ${d}`;i(r,"width",`${c}`),i(r,"height",`${d}`),i(t,"preserveAspectRatio",getComputedStyle(t).getPropertyValue("--preserve-aspect-ratio")||"xMinYMin meet"),i(t,"viewBox",u)&&t.classList.toggle("__reflow__")}))}(e),o&&window.requestAnimationFrame(a)};return a(),()=>{o=!1}}const l=Symbol(),s=document.currentScript;((t=document)=>{if("undefined"==typeof window)throw new Error("Marp Core's browser script is valid only in browser context.");if(t[l])return t[l];const e=a({target:t}),r=()=>{e(),delete t[l]};Object.defineProperty(t,l,{configurable:!0,value:r})})(s?s.getRootNode():document)}();
</script></foreignObject></svg></div>
      </body>
    </html>
  
